% Ladataan mittaustulokset
load las10t4data

% Valitaan kertaluvut
na = 1;
nb = 2;
nahat = 1;
nbhat = 2;

% Estimoidaan ARX-filtteri
data = iddata(y, u, 1);
th = arx(data, [nahat nbhat 0])%#ok
[Ahat, Bhat, Chat, Dhat, Fhat] = polydata(th);
% ja lasketaan sen antama ennusteaikasarja
ysim = sim(th, u);

% filtteridn y ja u 
yf = filter(1, Ahat, y);
uf = filter(1, Ahat, u);

% Fitataan ARX malli filtteridylle datalle:
dataf = iddata(yf, uf, 1);
th2 = arx(dataf, [na nb 0])%#ok
% ennuste
[A, B, C, D, F] = polydata(th2);
ysimf = sim(th2, uf);
ysim2 = filter(Ahat, 1, ysimf);

hold on;
plot(y);
plot(ysim, 'k');
plot(ysim2, 'r');
t = '$ln((L(\alpha,\hat{\tau}_{\alpha})))$';
legend('y', 'yhat', 'yhat_f', 'Location', 'NorthWest')
axis tight
grid on

